/*
 *    File sform.cpp
 *      Demonstrates the use of the SCROLLEDFORM Object
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mguipp.h"

#include "mguitest.hpp"

class CaSForm : public CmCallback {
	CmShell *shell;
	CmPixmap *pixmap;
public:
	CaSForm(void);
	void closeDialog(void) { delete shell; delete this; };
	void newImage(void);
};

/**********************************************************
 *	This callback changes the image viewed
 **********************************************************/
void CaSForm::newImage(void)
{
    char fname[128], dirname[128];

    strcpy(dirname, MGetSysDir());
    fname[0] = '\0';
    if (MFileSelection("Select New Image", "*.bmp", fname, dirname, True))
    {
	strcat(dirname, fname);
	pixmap->setImage(dirname);
    }
}

/*****************************************************
 *	This function opens the dialog when the
 *	corresponding menu item is selected
 *****************************************************/
CaSForm::CaSForm(void)
{
    CmForm *form, *sform;
    CmSFile *sfile;
    CmPushButton *pb;

    shell = new CmShell("Test Scrolled Form", SF_NO_CLOSE | SF_NO_MAXIMIZE);

    form = new CmColForm(shell);

    sform = new CmScrolledForm(form, 200, 250);

    new CmLabel(sform, "Label inside the scrolled form", TIMES_MEDIUM);
    pixmap = new CmPixmap(sform, "paulina1.bmp");

    sfile = new CmSFile(form, __FILE__, FIXED_MEDIUM, 10, 50);
    sfile->setColor(darkblue, white);

    form = new CmColForm(shell);

    pb = new CmPushButton(form, "New Image", TIMES_MEDIUM);
    pb->setCallback(this, (VOID_CB)&CaSForm::newImage);

    pb = new CmPushButton(form, "Close", TIMES_MEDIUM);
    pb->setCallback(this, (VOID_CB)&CaSForm::closeDialog);

    shell->realize();
}

void SFormDemo(void)
{
	new CaSForm;
}
